Imports System.Data.Entity

Public Class SchoolContext
        Inherits Entity.DbContext

    Public Sub New()
        Database.SetInitializer(New MigrateDatabaseToLatestVersion(Of SchoolContext, Migrations.Configuration)(NameOf(SchoolContext)))
    End Sub

    Public Property Courses As Entity.DbSet(Of Models.Course)

        Public Property Enrollments As Entity.DbSet(Of Models.Enrollment)

        Public Property Students As Entity.DbSet(Of Models.Student)

        Public Property Departments As Entity.DbSet(Of Models.Department)

        Public Property Instructors As Entity.DbSet(Of Models.Instructor)

        Public Property OfficeAssignments As Entity.DbSet(Of Models.OfficeAssignment)

        Public Property CourseAssignments As Entity.DbSet(Of Models.CourseAssignment)

        Public Property People As Entity.DbSet(Of Models.Person)

        Protected Overrides Sub OnModelCreating(modelBuilder As DbModelBuilder)
            modelBuilder.Entity(Of Models.Course)().ToTable(NameOf(Models.Course))
            modelBuilder.Entity(Of Models.Enrollment)().ToTable(NameOf(Models.Enrollment))
            modelBuilder.Entity(Of Models.Student)().ToTable(NameOf(Models.Student))
            modelBuilder.Entity(Of Models.Department)().ToTable(NameOf(Models.Department))
            modelBuilder.Entity(Of Models.Instructor)().ToTable(NameOf(Models.Instructor))
            modelBuilder.Entity(Of Models.OfficeAssignment)().ToTable(NameOf(Models.OfficeAssignment))
            modelBuilder.Entity(Of Models.CourseAssignment)().ToTable(NameOf(Models.CourseAssignment))
            modelBuilder.Entity(Of Models.Person)().ToTable(NameOf(Models.Person))
            modelBuilder.Entity(Of Models.CourseAssignment)().HasKey(Function(c) New With {c.CourseID, c.InstructorID})
        End Sub

    End Class
