﻿#Const Type = "Begin"
'#Const Type = "Final"

#If Type = "Begin" Then

#Region "snippet_Begin"

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations
Imports System.ComponentModel.DataAnnotations.Schema

Namespace Models

    Public Class Department

        Public Property DepartmentID As Integer

        <StringLength(50, MinimumLength:=3)>
        Public Property Name As String

        <DataType(DataType.Currency)>
        <Column(TypeName:="money")>
        Public Property Budget As Decimal

        <DataType(DataType.Date)>
        <DisplayFormat(DataFormatString:="{0:yyyy-MM-dd}", ApplyFormatInEditMode:=True)>
        <Display(Name:="Start Date")>
        Public Property StartDate As DateTime

        Public Property InstructorID As Integer?

        Public Property Administrator As Instructor

        Public Property Courses As ICollection(Of Course)
    End Class
End Namespace

#End Region

#ElseIf Type = "Final" Then

#Region "snippet_Final"
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations
Imports System.ComponentModel.DataAnnotations.Schema

Namespace Models

    Public Class Department

        Public Property DepartmentID As Integer

        <StringLength(50, MinimumLength:=3)>
        Public Property Name As String

        <DataType(DataType.Currency)>
        <Column(TypeName:="money")>
        Public Property Budget As Decimal

        <DataType(DataType.Date)>
        <DisplayFormat(DataFormatString:="{0:yyyy-MM-dd}", ApplyFormatInEditMode:=True)>
        <Display(Name:="Start Date")>
        Public Property StartDate As DateTime

        Public Property InstructorID As Integer?

        <Timestamp>
        Public Property RowVersion As Byte()

        Public Property Administrator As Instructor

        Public Property Courses As ICollection(Of Course)
    End Class
End Namespace
#End Region

#End If