﻿#Const Type = "Intro"
'#Const Type = "DataType1"
'#Const Type = "StringLength"
'#Const Type = "Column"
'#Const Type = "BeforeInheritance"
'#Const Type = "AfterInheritance"


#If Type = "Intro" Then

Imports System
Imports System.Collections.Generic

Namespace Models

    Public Class Student

        Public Property ID As Integer

        Public Property LastName As String

        Public Property FirstMidName As String

        Public Property EnrollmentDate As DateTime

        Public Property Enrollments As ICollection(Of Enrollment)
    End Class
End Namespace

#ElseIf Type = "DataType1" Then

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations

Namespace Models

    Public Class Student

        Public Property ID As Integer

        Public Property LastName As String

        Public Property FirstMidName As String

        <DataType(DataType.Date)>
        <DisplayFormat(DataFormatString:="{0:yyyy-MM-dd}", ApplyFormatInEditMode:=True)>
        Public Property EnrollmentDate As DateTime

        Public Property Enrollments As ICollection(Of Enrollment)
    End Class
End Namespace

#ElseIf Type = "StringLength" Then


Imports System
Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations

Namespace Models

    Public Class Student

        Public Property ID As Integer

        <StringLength(50)>
        Public Property LastName As String

        <StringLength(50, ErrorMessage:="First name cannot be longer than 50 characters.")>
        Public Property FirstMidName As String

        <DataType(DataType.Date)>
        <DisplayFormat(DataFormatString:="{0:yyyy-MM-dd}", ApplyFormatInEditMode:=True)>
        Public Property EnrollmentDate As DateTime

        Public Property Enrollments As ICollection(Of Enrollment)
    End Class
End Namespace

#ElseIf Type = "Column" Then

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations
Imports System.ComponentModel.DataAnnotations.Schema

Namespace Models

    Public Class Student

        Public Property ID As Integer

        <StringLength(50)>
        Public Property LastName As String

        <StringLength(50, ErrorMessage:="First name cannot be longer than 50 characters.")>
        <Column("FirstName")>
        Public Property FirstMidName As String

        <DataType(DataType.Date)>
        <DisplayFormat(DataFormatString:="{0:yyyy-MM-dd}", ApplyFormatInEditMode:=True)>
        Public Property EnrollmentDate As DateTime

        Public Property Enrollments As ICollection(Of Enrollment)
    End Class
End Namespace


#ElseIf Type = "BeforeInheritance" Then

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations
Imports System.ComponentModel.DataAnnotations.Schema

Namespace Models

    Public Class Student

        Public Property ID As Integer

        <Required>
        <StringLength(50)>
        <Display(Name:="Last Name")>
        Public Property LastName As String

        <Required>
        <StringLength(50, ErrorMessage:="First name cannot be longer than 50 characters.")>
        <Column("FirstName")>
        <Display(Name:="First Name")>
        Public Property FirstMidName As String

        <DataType(DataType.Date)>
        <DisplayFormat(DataFormatString:="{0:yyyy-MM-dd}", ApplyFormatInEditMode:=True)>
        <Display(Name:="Enrollment Date")>
        Public Property EnrollmentDate As DateTime

        <Display(Name:="Full Name")>
        Public ReadOnly Property FullName As String
            Get
                Return LastName & ", " & FirstMidName
            End Get
        End Property

        Public Property Enrollments As ICollection(Of Enrollment)
    End Class
End Namespace

#ElseIf Type = "AfterInheritance" Then

Imports System
Imports System.Collections.Generic
Imports System.ComponentModel.DataAnnotations
Imports System.ComponentModel.DataAnnotations.Schema

Namespace Models

    Public Class Student
        Inherits Person

        <DataType(DataType.Date)>
        <DisplayFormat(DataFormatString:="{0:yyyy-MM-dd}", ApplyFormatInEditMode:=True)>
        <Display(Name:="Enrollment Date")>
        Public Property EnrollmentDate As DateTime

        Public Property Enrollments As ICollection(Of Enrollment)
    End Class
End Namespace

#End If


